Index: libRTI/RTIambassador.cc
===================================================================
RCS file: /sources/certi/certi/libRTI/RTIambassador.cc,v
retrieving revision 3.101
diff -u -r3.101 RTIambassador.cc
--- libRTI/RTIambassador.cc	7 Dec 2008 20:16:16 -0000	3.101
+++ libRTI/RTIambassador.cc	2 Apr 2009 19:56:33 -0000
@@ -19,11 +19,11 @@
 // Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 // USA
 //
-// $Id: RTIambassador.cc,v 3.101 2008/12/07 20:16:16 gotthardp Exp $
+// $Id: RTIambassador.cc,v 3.101.4.2 2009/02/10 18:25:15 erk Exp $
 // ----------------------------------------------------------------------------
 
-
-#include "certi.hh"
+#include "RTI.hh"
+#include "fedtime.hh"
 
 #include "RTIambPrivateRefs.hh"
 #include "RTItypesImp.hh"
@@ -612,7 +612,7 @@
 //! Request Federation Save with time.
 void
 RTI::RTIambassador::requestFederationSave(const char *label,
-                                     const FedTime& theTime)
+                                     const RTI::FedTime& theTime)
     throw (RTI::FederationTimeAlreadyPassed,
            RTI::InvalidFederationTime,
            RTI::FederateNotExecutionMember,
@@ -626,7 +626,7 @@
     G.Out(pdGendoc,"enter RTIambassador::requestFederationSave with time");
 
     req.type = Message::REQUEST_FEDERATION_SAVE ;
-    req.setFedTime(theTime);
+    req.setFedTime(certi_cast<RTIfedTime>()(theTime).getTime());
     req.setLabel(label);
     // boolean true means time constrained
     req.setBoolean(true);
@@ -796,7 +796,7 @@
 
     req.type = Message::PUBLISH_OBJECT_CLASS ;
     req.setObjectClass(theClass);
-    req.setAHS(cast<AttributeHandleSetImp>()(attributeList).getAttributeHandles());
+    req.setAHS(certi_cast<AttributeHandleSetImp>()(attributeList).getAttributeHandles());
     G.Out(pdGendoc,"      ====>executeService PUBLISH_OBJECT_CLASS");
     privateRefs->executeService(&req, &rep);
     G.Out(pdGendoc,"exit  RTIambassador::publishObjectClass");
@@ -870,7 +870,7 @@
     G.Out(pdGendoc,"enter RTIambassador::subscribeObjectClassAttributes");
     req.type = Message::SUBSCRIBE_OBJECT_CLASS_ATTRIBUTES ;
     req.setObjectClass(theClass);
-    req.setAHS(cast<AttributeHandleSetImp>()(attributeList).getAttributeHandles());
+    req.setAHS(certi_cast<AttributeHandleSetImp>()(attributeList).getAttributeHandles());
     req.setBoolean(active);
 
     privateRefs->executeService(&req, &rep);
@@ -975,11 +975,11 @@
     @param theTime       Federation time
     @param theTag        User supplied tag
 */
-EventRetractionHandle
+RTI::EventRetractionHandle
 RTI::RTIambassador::
 updateAttributeValues(ObjectHandle theObject,
                       const AttributeHandleValuePairSet& theAttributes,
-                      const FedTime& theTime,
+                      const RTI::FedTime& theTime,
                       const char *theTag)
     throw (RTI::ObjectNotKnown,
            RTI::AttributeNotDefined,
@@ -996,13 +996,13 @@
 
     req.type = Message::UPDATE_ATTRIBUTE_VALUES ;
     req.setObject(theObject);
-    req.setFedTime(theTime);
+    req.setFedTime(certi_cast<RTIfedTime>()(theTime).getTime());
     if ( theTag == NULL)
        {
        throw RTI::RTIinternalError ("Calling updateAttributeValues with Tag NULL");
        }
     req.setTag(theTag);
-    req.setAHVPS(cast<AttributeHandleValuePairSetImp>()(theAttributes).getAttributeHandleValuePairs());
+    req.setAHVPS(certi_cast<AttributeHandleValuePairSetImp>()(theAttributes).getAttributeHandleValuePairs());
     req.setBoolean(true);
 
     privateRefs->executeService(&req, &rep);
@@ -1038,7 +1038,7 @@
        throw RTI::RTIinternalError ("Calling updateAttributeValues with Tag NULL");
        }
     req.setTag(theTag);
-    req.setAHVPS(cast<AttributeHandleValuePairSetImp>()(theAttributes).getAttributeHandleValuePairs());
+    req.setAHVPS(certi_cast<AttributeHandleValuePairSetImp>()(theAttributes).getAttributeHandleValuePairs());
     req.setBoolean(false);
 
     privateRefs->executeService(&req, &rep);
@@ -1054,10 +1054,10 @@
     @param theTime Federation time
     @param theTag User-supplied tag
 */
-EventRetractionHandle
+RTI::EventRetractionHandle
 RTI::RTIambassador::sendInteraction(InteractionClassHandle theInteraction,
                                const ParameterHandleValuePairSet& theParameters,
-                               const FedTime& theTime,
+                               const RTI::FedTime& theTime,
                                const char *theTag)
     throw (RTI::InteractionClassNotDefined,
            RTI::InteractionClassNotPublished,
@@ -1073,13 +1073,13 @@
 
     req.type = Message::SEND_INTERACTION ;
     req.setInteractionClass(theInteraction);
-    req.setFedTime(theTime);
+    req.setFedTime(certi_cast<RTIfedTime>()(theTime).getTime());
     if (theTag == NULL)
        {
        throw RTI::RTIinternalError ("Calling sendInteraction with Tag NULL") ;
        }
     req.setTag((std::string)theTag);
-    req.setPHVPS(cast<ParameterHandleValuePairSetImp>()(theParameters).getParameterHandleValuePairs());
+    req.setPHVPS(certi_cast<ParameterHandleValuePairSetImp>()(theParameters).getParameterHandleValuePairs());
     req.setRegion(0);
     req.setBoolean(true);
 
@@ -1115,7 +1115,7 @@
        throw RTI::RTIinternalError ("Calling sendIntercation with Tag NULL") ;
        }
     req.setTag((std::string)theTag);
-    req.setPHVPS(cast<ParameterHandleValuePairSetImp>()(theParameters).getParameterHandleValuePairs());
+    req.setPHVPS(certi_cast<ParameterHandleValuePairSetImp>()(theParameters).getParameterHandleValuePairs());
     req.setRegion(0);
     req.setBoolean(false);
   
@@ -1130,9 +1130,9 @@
     @param theTime Federation time
     @param theTag user supplied tag
 */
-EventRetractionHandle
+RTI::EventRetractionHandle
 RTI::RTIambassador::deleteObjectInstance(ObjectHandle theObject,
-                                    const FedTime& theTime,
+                                    const RTI::FedTime& theTime,
                                     const char *theTag)
     throw (RTI::ObjectNotKnown,
            RTI::DeletePrivilegeNotHeld,
@@ -1147,7 +1147,7 @@
 
     req.type = Message::DELETE_OBJECT_INSTANCE ;
     req.setObject(theObject);
-    req.setFedTime(theTime);
+    req.setFedTime(certi_cast<RTIfedTime>()(theTime).getTime());
     if (theTag == NULL)
        {
        throw RTI::RTIinternalError ("Calling deleteObjectInstance with Tag NULL") ;
@@ -1222,7 +1222,7 @@
     req.type = Message::CHANGE_ATTRIBUTE_TRANSPORTATION_TYPE ;
     req.setObject(theObject);
     req.setTransportation(theType);
-    req.setAHS(cast<AttributeHandleSetImp>()(theAttributes).getAttributeHandles());
+    req.setAHS(certi_cast<AttributeHandleSetImp>()(theAttributes).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
 }
@@ -1262,7 +1262,7 @@
     G.Out(pdGendoc,"enter RTIambassador::requestObjectAttributeValueUpdate");
     req.type = Message::REQUEST_OBJECT_ATTRIBUTE_VALUE_UPDATE ;
     req.setObject(theObject);
-    req.setAHS(cast<AttributeHandleSetImp>()(ahs).getAttributeHandles());
+    req.setAHS(certi_cast<AttributeHandleSetImp>()(ahs).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
     G.Out(pdGendoc,"exit  RTIambassador::requestObjectAttributeValueUpdate");
@@ -1283,7 +1283,7 @@
     G.Out(pdGendoc,"enter RTIambassador::requestClassAttributeValueUpdate");
     req.type = Message::REQUEST_CLASS_ATTRIBUTE_VALUE_UPDATE ;
     req.setObjectClass(theClass);
-    req.setAHS(cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
+    req.setAHS(certi_cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
     G.Out(pdGendoc,"exit  RTIambassador::requestClassAttributeValueUpdate");
@@ -1308,7 +1308,7 @@
 
     req.type = Message::UNCONDITIONAL_ATTRIBUTE_OWNERSHIP_DIVESTITURE ;
     req.setObject(theObject);
-    req.setAHS(cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
+    req.setAHS(certi_cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
 }
@@ -1339,7 +1339,7 @@
        throw RTI::RTIinternalError ("Calling negotiatedAttributeOwnershipDivestiture with Tag NULL") ;
        }
     req.setTag(theTag);
-    req.setAHS(cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
+    req.setAHS(certi_cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
 }
@@ -1371,7 +1371,7 @@
        throw RTI::RTIinternalError ("Calling attributeOwnershipAcquisition with Tag NULL") ;
        }
     req.setTag(theTag);
-    req.setAHS(cast<AttributeHandleSetImp>()(desiredAttributes).getAttributeHandles());
+    req.setAHS(certi_cast<AttributeHandleSetImp>()(desiredAttributes).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
 }
@@ -1396,7 +1396,7 @@
 
     req.type = Message::ATTRIBUTE_OWNERSHIP_RELEASE_RESPONSE ;
     req.setObject(theObject);
-    req.setAHS(cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
+    req.setAHS(certi_cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
 
@@ -1427,7 +1427,7 @@
 
     req.type = Message::CANCEL_NEGOTIATED_ATTRIBUTE_OWNERSHIP_DIVESTITURE ;
     req.setObject(theObject);
-    req.setAHS(cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
+    req.setAHS(certi_cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
 }
@@ -1452,7 +1452,7 @@
 
     req.type = Message::CANCEL_ATTRIBUTE_OWNERSHIP_ACQUISITION ;
     req.setObject(theObject);
-    req.setAHS(cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
+    req.setAHS(certi_cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
 }
@@ -1479,7 +1479,7 @@
 
     req.type = Message::ATTRIBUTE_OWNERSHIP_ACQUISITION_IF_AVAILABLE ;
     req.setObject(theObject);
-    req.setAHS(cast<AttributeHandleSetImp>()(desired).getAttributeHandles());
+    req.setAHS(certi_cast<AttributeHandleSetImp>()(desired).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
 }
@@ -1531,8 +1531,8 @@
 // ----------------------------------------------------------------------------
 // Enable Time Regulation
 void
-RTI::RTIambassador::enableTimeRegulation(const FedTime& theFederateTime,
-                                    const FedTime& theLookahead)
+RTI::RTIambassador::enableTimeRegulation(const RTI::FedTime& theFederateTime,
+                                    const RTI::FedTime& theLookahead)
     throw (RTI::RTIinternalError, RTI::RestoreInProgress, 
 	   RTI::SaveInProgress, RTI::FederateNotExecutionMember, 
 	   RTI::ConcurrentAccessAttempted, RTI::InvalidLookahead, 
@@ -1541,8 +1541,8 @@
 {
     Message req, rep ;
     req.type = Message::ENABLE_TIME_REGULATION ;
-    req.setFedTime(theFederateTime);
-    req.setLookahead(theLookahead);
+    req.setFedTime(certi_cast<RTIfedTime>()(theFederateTime).getTime());
+    req.setLookahead(certi_cast<RTIfedTime>()(theLookahead).getTime());
     req.setBoolean(true);
     privateRefs->executeService(&req, &rep);
 }
@@ -1603,7 +1603,7 @@
 // ----------------------------------------------------------------------------
 // Time Advance Request
 void
-RTI::RTIambassador::timeAdvanceRequest(const FedTime& theTime)
+RTI::RTIambassador::timeAdvanceRequest(const RTI::FedTime& theTime)
     throw (RTI::TimeAdvanceAlreadyInProgress,
            RTI::FederationTimeAlreadyPassed,
            RTI::InvalidFederationTime,
@@ -1618,14 +1618,14 @@
     Message req, rep ;
 
     req.type = Message::TIME_ADVANCE_REQUEST ;
-    req.setFedTime(theTime);
+    req.setFedTime(certi_cast<RTIfedTime>()(theTime).getTime());
     privateRefs->executeService(&req, &rep);
 }
 
 // ----------------------------------------------------------------------------
 // Time Advance Request Available
 void
-RTI::RTIambassador::timeAdvanceRequestAvailable(const FedTime& theTime)
+RTI::RTIambassador::timeAdvanceRequestAvailable(const RTI::FedTime& theTime)
     throw (RTI::RTIinternalError, RTI::RestoreInProgress, RTI::SaveInProgress, 
 	   RTI::ConcurrentAccessAttempted, RTI::FederateNotExecutionMember, 
 	   RTI::EnableTimeConstrainedPending, RTI::EnableTimeRegulationPending, 
@@ -1635,7 +1635,7 @@
     Message req, rep ;
 
     req.type = Message::TIME_ADVANCE_REQUEST_AVAILABLE ;
-    req.setFedTime(theTime);
+    req.setFedTime(certi_cast<RTIfedTime>()(theTime).getTime());
 
     privateRefs->executeService(&req, &rep);
 }
@@ -1643,7 +1643,7 @@
 // ----------------------------------------------------------------------------
 // Next Event Request
 void
-RTI::RTIambassador::nextEventRequest(const FedTime& theTime)
+RTI::RTIambassador::nextEventRequest(const RTI::FedTime& theTime)
     throw (RTI::TimeAdvanceAlreadyInProgress,
            RTI::FederationTimeAlreadyPassed,
            RTI::InvalidFederationTime,
@@ -1658,14 +1658,14 @@
     Message req, rep ;
 
     req.type = Message::NEXT_EVENT_REQUEST ;
-    req.setFedTime(theTime);
+    req.setFedTime(certi_cast<RTIfedTime>()(theTime).getTime());
     privateRefs->executeService(&req, &rep);
 }
 
 // ----------------------------------------------------------------------------
 // Next Event Request Available
 void
-RTI::RTIambassador::nextEventRequestAvailable(const FedTime& theTime)
+RTI::RTIambassador::nextEventRequestAvailable(const RTI::FedTime& theTime)
     throw (RTI::RTIinternalError, RTI::RestoreInProgress, RTI::SaveInProgress, 
 	   RTI::ConcurrentAccessAttempted, RTI::FederateNotExecutionMember, 
 	   RTI::EnableTimeConstrainedPending, RTI::EnableTimeRegulationPending, 
@@ -1675,14 +1675,14 @@
     Message req, rep ;
 
     req.type = Message::NEXT_EVENT_REQUEST_AVAILABLE ;
-    req.setFedTime(theTime);
+    req.setFedTime(certi_cast<RTIfedTime>()(theTime).getTime());
     privateRefs->executeService(&req, &rep);
 }
 
 // ----------------------------------------------------------------------------
 // Flush Queue Request
 void
-RTI::RTIambassador::flushQueueRequest(const FedTime& theTime)
+RTI::RTIambassador::flushQueueRequest(const RTI::FedTime& theTime)
     throw (RTI::TimeAdvanceAlreadyInProgress,
            RTI::FederationTimeAlreadyPassed,
            RTI::InvalidFederationTime,
@@ -1698,7 +1698,7 @@
     Message req, rep ;
 
     req.type = Message::FLUSH_QUEUE_REQUEST ;
-    req.setFedTime(theTime);
+    req.setFedTime(certi_cast<RTIfedTime>()(theTime).getTime());
 
     privateRefs->executeService(&req, &rep);
 }
@@ -1738,7 +1738,7 @@
 // ----------------------------------------------------------------------------
 // Query LBTS
 void
-RTI::RTIambassador::queryLBTS(FedTime& theTime)
+RTI::RTIambassador::queryLBTS(RTI::FedTime& theTime)
     throw (RTI::FederateNotExecutionMember,
            RTI::ConcurrentAccessAttempted,
            RTI::SaveInProgress,
@@ -1750,13 +1750,13 @@
     req.type = Message::QUERY_LBTS ;
     privateRefs->executeService(&req, &rep);
 
-    theTime = rep.getFedTime();
+    certi_cast<RTIfedTime>()(theTime) = rep.getFedTime();
 }
 
 // ----------------------------------------------------------------------------
 // Query Federate Time
 void
-RTI::RTIambassador::queryFederateTime(FedTime& theTime)
+RTI::RTIambassador::queryFederateTime(RTI::FedTime& theTime)
     throw (RTI::FederateNotExecutionMember,
            RTI::ConcurrentAccessAttempted,
            RTI::SaveInProgress,
@@ -1768,13 +1768,13 @@
     req.type = Message::QUERY_FEDERATE_TIME ;
     privateRefs->executeService(&req, &rep);
 
-    theTime = rep.getFedTime();
+    certi_cast<RTIfedTime>()(theTime) = rep.getFedTime();
 }
 
 // ----------------------------------------------------------------------------
 // Query Minimum Next Event Time
 void
-RTI::RTIambassador::queryMinNextEventTime(FedTime& theTime)
+RTI::RTIambassador::queryMinNextEventTime(RTI::FedTime& theTime)
     throw (RTI::FederateNotExecutionMember,
            RTI::ConcurrentAccessAttempted,
            RTI::SaveInProgress,
@@ -1786,13 +1786,13 @@
     req.type = Message::QUERY_MIN_NEXT_EVENT_TIME ;
     privateRefs->executeService(&req, &rep);
 
-    theTime = rep.getFedTime();
+    certi_cast<RTIfedTime>()(theTime) = rep.getFedTime();
 }
 
 // ----------------------------------------------------------------------------
 // Modify Lookahead
 void
-RTI::RTIambassador::modifyLookahead(const FedTime& theLookahead)
+RTI::RTIambassador::modifyLookahead(const RTI::FedTime& theLookahead)
     throw (RTI::RTIinternalError, RTI::RestoreInProgress, RTI::SaveInProgress, 
 	   RTI::ConcurrentAccessAttempted, RTI::FederateNotExecutionMember, 
 	   RTI::InvalidLookahead)
@@ -1800,7 +1800,7 @@
     Message req, rep ;
 
     req.type = Message::MODIFY_LOOKAHEAD ;
-    req.setLookahead(theLookahead);
+    req.setLookahead(certi_cast<RTIfedTime>()(theLookahead).getTime());
 
     privateRefs->executeService(&req, &rep);
 }
@@ -1808,7 +1808,7 @@
 // ----------------------------------------------------------------------------
 // Query Lookahead
 void
-RTI::RTIambassador::queryLookahead(FedTime &theTime)
+RTI::RTIambassador::queryLookahead(RTI::FedTime &theTime)
     throw (RTI::FederateNotExecutionMember,
            RTI::ConcurrentAccessAttempted,
            RTI::SaveInProgress,
@@ -1820,19 +1820,13 @@
     req.type = Message::QUERY_LOOKAHEAD ;
     privateRefs->executeService(&req, &rep);
 
-    try { 
-        RTIfedTime &ret = dynamic_cast<RTIfedTime&>(theTime); 
-        ret = RTIfedTime((Double) rep.getFederationTimeDelta());
-    }
-    catch (std::bad_cast) {
-	throw RTI::RTIinternalError("theTime is not a RTIfedTime object");
-    }
+    certi_cast<RTIfedTime>()(theTime) = rep.getFederationTimeDelta().getTime();
 }
 
 // ----------------------------------------------------------------------------
 // Retract
 void
-RTI::RTIambassador::retract(EventRetractionHandle handle)
+RTI::RTIambassador::retract(RTI::EventRetractionHandle handle)
     throw (RTI::RTIinternalError, RTI::RestoreInProgress, RTI::SaveInProgress, 
 	   RTI::ConcurrentAccessAttempted, RTI::FederateNotExecutionMember, 
 	   RTI::InvalidRetractionHandle)
@@ -1862,7 +1856,7 @@
     req.type = Message::CHANGE_ATTRIBUTE_ORDER_TYPE ;
     req.setObject(theObject);
     req.setOrdering(theType);
-    req.setAHS(cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
+    req.setAHS(certi_cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
 }
@@ -2080,7 +2074,7 @@
     req.type = Message::DDM_ASSOCIATE_REGION ;
     req.setObject(object);
     req.setRegion(get_handle(region));
-    req.setAHS(cast<AttributeHandleSetImp>()(attributes).getAttributeHandles());
+    req.setAHS(certi_cast<AttributeHandleSetImp>()(attributes).getAttributeHandles());
 
     privateRefs->executeService(&req, &rep);
     D[pdDebug] << "- Associate Region for Updates" << endl ;
@@ -2146,7 +2140,7 @@
     req.type = Message::DDM_SUBSCRIBE_ATTRIBUTES ;
     req.setObjectClass(object_class);
     req.setRegion(get_handle(region));
-    req.setAHS(cast<AttributeHandleSetImp>()(attributes).getAttributeHandles());
+    req.setAHS(certi_cast<AttributeHandleSetImp>()(attributes).getAttributeHandles());
     req.setBoolean(passive);
 
     privateRefs->executeService(&req, &rep);
@@ -2234,10 +2228,10 @@
 
 // ----------------------------------------------------------------------------
 // Send Interaction With Region
-EventRetractionHandle
+RTI::EventRetractionHandle
 RTI::RTIambassador::sendInteractionWithRegion(InteractionClassHandle interaction,
                                          const ParameterHandleValuePairSet &par,
-                                         const FedTime &time,
+                                         const RTI::FedTime &time,
                                          const char *tag,
                                          const Region &region)
     throw (RTI::InteractionClassNotDefined,
@@ -2256,8 +2250,8 @@
 
     req.setType(Message::SEND_INTERACTION);
     req.setInteractionClass(interaction);
-    req.setPHVPS(cast<ParameterHandleValuePairSetImp>()(par).getParameterHandleValuePairs());
-    req.setFedTime(time);
+    req.setPHVPS(certi_cast<ParameterHandleValuePairSetImp>()(par).getParameterHandleValuePairs());
+    req.setFedTime(certi_cast<RTIfedTime>()(time).getTime());
     if ( tag == NULL )
        {
        throw RTI::RTIinternalError ("Calling sendInteractionWithRegion with Tag NULL");
@@ -2291,7 +2285,7 @@
 
     req.setType(Message::SEND_INTERACTION);
     req.setInteractionClass(interaction);
-    req.setPHVPS(cast<ParameterHandleValuePairSetImp>()(par).getParameterHandleValuePairs());
+    req.setPHVPS(certi_cast<ParameterHandleValuePairSetImp>()(par).getParameterHandleValuePairs());
     if ( tag == NULL )
        {
        throw RTI::RTIinternalError ("Calling sendInteractionWithRegion with Tag NULL");
@@ -2316,7 +2310,7 @@
 
     Message req, rep ;
     req.setType(Message::DDM_REQUEST_UPDATE);
-    req.setAHS(cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
+    req.setAHS(certi_cast<AttributeHandleSetImp>()(attrs).getAttributeHandles());
     req.setRegion(get_handle(region));
     privateRefs->executeService(&req, &rep);    
 }
@@ -2955,4 +2949,4 @@
     privateRefs->executeService(&req, &rep);
 }
 
-// $Id: RTIambassador.cc,v 3.101 2008/12/07 20:16:16 gotthardp Exp $
+// $Id: RTIambassador.cc,v 3.101.4.2 2009/02/10 18:25:15 erk Exp $
Index: libRTI/RTIambPrivateRefs.hh
===================================================================
RCS file: /sources/certi/certi/libRTI/RTIambPrivateRefs.hh,v
retrieving revision 3.7
diff -u -r3.7 RTIambPrivateRefs.hh
--- libRTI/RTIambPrivateRefs.hh	7 Dec 2008 20:16:16 -0000	3.7
+++ libRTI/RTIambPrivateRefs.hh	2 Apr 2009 19:56:32 -0000
@@ -19,10 +19,11 @@
 // Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 // USA
 //
-// $Id: RTIambPrivateRefs.hh,v 3.7 2008/12/07 20:16:16 gotthardp Exp $
+// $Id: RTIambPrivateRefs.hh,v 3.7.4.1 2009/01/05 13:34:52 gotthardp Exp $
 // ----------------------------------------------------------------------------
 
 #include "RTI.hh"
+#include "fedtime.hh"
 #include "Message.hh"
 #include "RootObject.hh"
 #include "MessageBuffer.hh"
@@ -59,4 +60,4 @@
     MessageBuffer msgBufSend,msgBufReceive ;
 };
 
-// $Id: RTIambPrivateRefs.hh,v 3.7 2008/12/07 20:16:16 gotthardp Exp $
+// $Id: RTIambPrivateRefs.hh,v 3.7.4.1 2009/01/05 13:34:52 gotthardp Exp $
Index: libRTI/RTIambPrivateRefs.cc
===================================================================
RCS file: /sources/certi/certi/libRTI/RTIambPrivateRefs.cc,v
retrieving revision 3.16
diff -u -r3.16 RTIambPrivateRefs.cc
--- libRTI/RTIambPrivateRefs.cc	7 Dec 2008 20:16:16 -0000	3.16
+++ libRTI/RTIambPrivateRefs.cc	2 Apr 2009 19:56:32 -0000
@@ -19,7 +19,7 @@
 // Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 // USA
 //
-// $Id: RTIambPrivateRefs.cc,v 3.16 2008/12/07 20:16:16 gotthardp Exp $
+// $Id: RTIambPrivateRefs.cc,v 3.16.4.2 2009/02/10 18:25:14 erk Exp $
 // ----------------------------------------------------------------------------
 
 #include <config.h>
@@ -29,7 +29,7 @@
 #include <sstream>
 
 namespace {
-PrettyDebug D("LIBRTI", __FILE__);
+static PrettyDebug D("LIBRTI", __FILE__);
 static PrettyDebug G("GENDOC",__FILE__);
 }
 
@@ -712,7 +712,7 @@
             if (msg->getBoolean())
                fed_amb->reflectAttributeValues(msg->getObject(),
                                                *attributes,
-                                               msg->getFedTime(),
+                                               RTIfedTime(msg->getFedTime()),
                                                (msg->getTag()).c_str(),
                                                msg->getEventRetraction());
             else
@@ -733,7 +733,7 @@
                 fed_amb->receiveInteraction(
                                         msg->getInteractionClass(),
                                         *parameters,
-                                        msg->getFedTime(),
+                                        RTIfedTime(msg->getFedTime()),
                                         (msg->getTag()).c_str(),
                                         msg->getEventRetraction());
             else
@@ -752,7 +752,7 @@
             if (msg->getBoolean()) {
                 fed_amb->removeObjectInstance(
                                           msg->getObject(),
-                                          msg->getFedTime(),
+                                          RTIfedTime(msg->getFedTime()),
                                           (msg->getTag()).c_str(),
                                           msg->getEventRetraction());
             }
@@ -884,21 +884,21 @@
 
       case Message::TIME_ADVANCE_GRANT:
         try {
-            fed_amb->timeAdvanceGrant(msg->getFedTime());
+            fed_amb->timeAdvanceGrant(RTIfedTime(msg->getFedTime()));
         }
         CATCH_FEDERATE_AMBASSADOR_EXCEPTIONS("timeAdvanceGrant")
         break ;
 
       case Message::TIME_REGULATION_ENABLED:
         try {
-            fed_amb->timeRegulationEnabled(msg->getFedTime());
+            fed_amb->timeRegulationEnabled(RTIfedTime(msg->getFedTime()));
         }
         CATCH_FEDERATE_AMBASSADOR_EXCEPTIONS("timeRegulationEnabled")
         break ;
 
       case Message::TIME_CONSTRAINED_ENABLED:
         try {
-            fed_amb->timeConstrainedEnabled(msg->getFedTime());
+            fed_amb->timeConstrainedEnabled(RTIfedTime(msg->getFedTime()));
         }
         CATCH_FEDERATE_AMBASSADOR_EXCEPTIONS("timeConstrainedEnabled")
         break ;
@@ -908,4 +908,4 @@
     }
 }
 
-// $Id: RTIambPrivateRefs.cc,v 3.16 2008/12/07 20:16:16 gotthardp Exp $
+// $Id: RTIambPrivateRefs.cc,v 3.16.4.2 2009/02/10 18:25:14 erk Exp $
Index: libRTI/RTItypesImp.cc
===================================================================
RCS file: /sources/certi/certi/libRTI/RTItypesImp.cc,v
retrieving revision 3.1
diff -u -r3.1 RTItypesImp.cc
--- libRTI/RTItypesImp.cc	7 Dec 2008 20:16:17 -0000	3.1
+++ libRTI/RTItypesImp.cc	2 Apr 2009 19:56:33 -0000
@@ -16,7 +16,7 @@
 // License along with this program ; if not, write to the Free Software
 // Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 //
-// $Id: RTItypesImp.cc,v 3.1 2008/12/07 20:16:17 gotthardp Exp $
+// $Id: RTItypesImp.cc,v 3.1.4.1 2009/02/10 18:25:14 erk Exp $
 // ----------------------------------------------------------------------------
 
 #include "certi.hh"
@@ -30,12 +30,9 @@
 
 using namespace certi ;
 
-namespace {
-
 static PrettyDebug D("LIBRTI", __FILE__);
 static PrettyDebug G("GENDOC",__FILE__);
 
-}
 
 // ----------------------------------------------------------------------------
 AttributeHandleValuePairSetImp::AttributeHandleValuePairSetImp(ULong size)
@@ -539,4 +536,4 @@
         throw RTI::ArrayIndexOutOfBounds("Extent index above limit");
 }
 
-// $Id: RTItypesImp.cc,v 3.1 2008/12/07 20:16:17 gotthardp Exp $
+// $Id: RTItypesImp.cc,v 3.1.4.1 2009/02/10 18:25:14 erk Exp $
